"""Max Water System driver code."""
import threading
import time
from random import randint
from Channel import write_tag, read_tag
from device_base import deviceBase

PLC_IP_ADDRESS = "192.168.1.10"
WATCHDOG_SEND_PERIOD = 3600  # seconds


class start(threading.Thread, deviceBase):
    """Driver class."""

    def __init__(self, name=None, number=None, mac=None, Q=None, mcu=None, companyId=None, offset=None, mqtt=None, Nodes=None):
        """Initialize the driver."""
        threading.Thread.__init__(self)
        deviceBase.__init__(self, name=name, number=number, mac=mac, Q=Q, mcu=mcu, companyId=companyId, offset=offset, mqtt=mqtt, Nodes=Nodes)

        self.daemon = True
        self.version = "7"
        self.finished = threading.Event()
        threading.Thread.start(self)

    def register(self):
        """Required function for all drivers, its goal is to upload some piece of data about your device so it can be seen on the web."""
        self.channels["status"]["last_value"] = ""

    def run(self):
        """Run the driver."""
        watchdog = self.advvfdipp_watchdog()
        self.sendtodbDev(1, 'watchdog', watchdog, 0)
        watchdog_send_timestamp = time.time()
        watchdog_loops = 0
        watchdog_check_after = 5000

        while True:
            watchdog_loops += 1
            if (watchdog_loops >= watchdog_check_after):
                test_watchdog = self.advvfdipp_watchdog()
                if test_watchdog != watchdog or (time.time() - watchdog_send_timestamp) > WATCHDOG_SEND_PERIOD:
                    self.sendtodbDev(1, 'watchdog', test_watchdog, 0, 'advvfdipp')
                    watchdog_send_timestamp = time.time()
                    watchdog = test_watchdog
                watchdog_loops = 0

    def advvfdipp_watchdog(self):
        """Write a random integer to the PLC and then 1 seconds later check that it has been decremented by 1."""
        randval = randint(0, 32767)
        write_tag(str(PLC_IP_ADDRESS), 'watchdog_INT', randval)
        time.sleep(1)
        watchdog_val = read_tag(str(PLC_IP_ADDRESS), 'watchdog_INT')
        try:
            return (randval - 1) == watchdog_val[0]
        except (KeyError, TypeError):
            return False
